var $Sha1={};
$Sha1.hexcase = 0;

$Sha1.encode=function (s) 
{
    return $Sha1.binb2hex($Sha1.core_sha1($Sha1.AlignSHA1(s)));
}

$Sha1.core_sha1=function (blockArray) 
{
    var x = blockArray; 
    var w = Array(80);
    var a = 1732584193;
    var b = -271733879;
    var c = -1732584194;
    var d = 271733878;
    var e = -1009589776;
    for (var i = 0; i < x.length; i += 16)
    {
        var olda = a;
        var oldb = b;
        var oldc = c;
        var oldd = d;
        var olde = e;
        for (var j = 0; j < 80; j++) 
        {
            if (j < 16)
            {
                w[j] = x[i + j];
            }
            else
            {
                w[j] = $Sha1.rol(w[j - 3] ^ w[j - 8] ^ w[j - 14] ^ w[j - 16], 1);
            }
            var t = $Sha1.safe_add($Sha1.safe_add($Sha1.rol(a, 5), $Sha1.sha1_ft(j, b, c, d)), $Sha1.safe_add($Sha1.safe_add(e, w[j]), $Sha1.sha1_kt(j)));
            e = d;
            d = c;
            c = $Sha1.rol(b, 30);
            b = a;
            a = t;
        }
        a = $Sha1.safe_add(a, olda);
        b = $Sha1.safe_add(b, oldb);
        c = $Sha1.safe_add(c, oldc);
        d = $Sha1.safe_add(d, oldd);
        e = $Sha1.safe_add(e, olde);
    }
    return new Array(a, b, c, d, e);
}

$Sha1.sha1_ft=function (t, b, c, d) 
{
    if (t < 20)return (b & c) | ((~b) & d);
    else if (t < 40)return b ^ c ^ d;
    else if (t < 60)return (b & c) | (b & d) | (c & d);
    return b ^ c ^ d; // t<80
}

$Sha1.sha1_kt=function (t) 
{
    return (t < 20) ? 1518500249 : (t < 40) ? 1859775393 : (t < 60) ? -1894007588 : -899497514;
}

$Sha1.safe_add=function (x, y) 
{
    var lsw = (x & 0xFFFF) + (y & 0xFFFF);
    var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
    return (msw << 16) | (lsw & 0xFFFF);
}

$Sha1.rol=function (num, cnt) 
{
    return (num << cnt) | (num >>> (32 - cnt));
}

$Sha1.AlignSHA1=function (str) 
{
    var nblk = ((str.length + 8) >> 6) + 1,
        blks = new Array(nblk * 16);
    for (var i = 0; i < nblk * 16; i++)
        blks[i] = 0;
    for (i = 0; i < str.length; i++)
        blks[i >> 2] |= str.charCodeAt(i) << (24 - (i & 3) * 8);
    blks[i >> 2] |= 0x80 << (24 - (i & 3) * 8);
    blks[nblk * 16 - 1] = str.length * 8;
    return blks;
}

$Sha1.binb2hex=function (binarray) 
{
    var hex_tab = $Sha1.hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
    var str = "";
    for (var i = 0; i < binarray.length * 4; i++) 
    {
        str += hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8 + 4)) & 0xF) +
        hex_tab.charAt((binarray[i >> 2] >> ((3 - i % 4) * 8)) & 0xF);
    }
    return str;
}